/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.controllers;


import gov.anl.aps.dm.portal.model.beans.RoleTypeFacade;
import gov.anl.aps.dm.portal.model.beans.UserExperimentRoleFacade;
import gov.anl.aps.dm.portal.model.beans.UserInfoFacade;
import gov.anl.aps.dm.portal.model.entities.Experiment;
import gov.anl.aps.dm.portal.model.entities.RoleType;
import gov.anl.aps.dm.portal.model.entities.UserInfo;
import gov.anl.aps.dm.portal.model.tempstorage.ExperimentUser;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;
import org.apache.log4j.Logger;

@Named("experimentUsersController")
@SessionScoped
public class ExperimentUsersController  implements Serializable {
    
    private static final Logger logger = Logger.getLogger(ExperimentUsersController.class.getName());
    
    @EJB
    private UserExperimentRoleFacade userExperimentRoleFacade;

    @EJB
    private UserInfoFacade userInfoFacade;

    @EJB
    private RoleTypeFacade roleTypeFacade;

    public ExperimentUsersController() {
        this.experimentUsersTable = new ExperimentUsersTable();
    }

    class ExperimentUsersTable extends DataTableController<ExperimentUser> {

//        @Override
//        public String getClassName() {
//            return "UserInfo";
//        }
//
//        @Override
//        public List<UserInfo> findAll() {
//            try {
//                return userInfoFacade.findUsersInExperiment(experiment.getId());
//            } catch (NumberFormatException e) {
//                return null;
//            }
//        }

        @Override
        public String getClassName() {
            return "ExperimentUser";
        }

        @Override
        public List<ExperimentUser> findAll() {
            experimentUsers.clear();
            try {
                List<UserInfo> list = userInfoFacade.findUsersInExperiment(experiment.getId());
                convertExperimentUsers(list);
                return experimentUsers;
            } catch (NumberFormatException e) {
                return null;
            }
        }
        
        void convertExperimentUsers(List<UserInfo> list) {
            List<RoleType> roleTypes = roleTypeFacade.findByRoleSystemType(false);
            generateColumns(roleTypes);
            for (UserInfo user : list) {
                ExperimentUser eUser = new ExperimentUser();
                eUser.setUsername(user.getUsername());
                eUser.setName(user.getLastName() + ", " + user.getFirstName());
                for (RoleType roleType : roleTypes) {
                    eUser.setIsInRole(roleType, user.inRole(roleType.getId(), experiment.getId()));
                }
                experimentUsers.add(eUser);
            }
        }
    }

    static class ColumnModel implements Serializable {
        private String header;
        private int property;

        public ColumnModel(String header, int property) {
            this.header = header;
            this.property = property;
        }

        public String getHeader() {
            return header;
        }

        public int getProperty() {
            return property;
        }
    }

    private ExperimentUsersTable experimentUsersTable;
    private Experiment experiment;
    private List<ExperimentUser> experimentUsers = new ArrayList<>();
    private List<ColumnModel> columns;

    public List<ColumnModel> getColumns() {
        return columns;
    }

    public void setColumns(List<ColumnModel> columns) {
        this.columns = columns;
    }

    public Experiment getExperiment() {
        return experiment;
    }

    public void setExperiment(Experiment experiment) {
        experimentUsersTable.resetList();
        this.experiment = experiment;
    }

    public ExperimentUsersTable getExperimentUsersTable() {
        return experimentUsersTable;
    }

    public void setExperimentUsersTable(ExperimentUsersTable experimentUsersTable) {
        this.experimentUsersTable = experimentUsersTable;
    }
    
    void generateColumns(List<RoleType> roleTypes) {
        for (RoleType role : roleTypes) {
            ColumnModel column = new ColumnModel(role.getName(), role.getId());
            columns.add(column);
        }
    }
    
//    public boolean getIsInRole() {
//        
//    }
//    
//    public void setIsInRole(boolean inRole)
//  
    
    
    
    
//    public String getCurrentEntityInstanceName() {
//        return null;
//    }
//    
//    public String remove() {
//        return null;
//    }
//    
//    public boolean canRemove(String removerUsername, UserInfo removee) {
//        return false;
//    }
//    
//    public boolean canAddUsers(String username) {
//        return true;
//    }
//    
//    public void setIsInRole(int roleId, String userId) {
//        
//    }
//    
//    public boolean canAssignManager(String userId) {
//        return true;
//    }
//    
//    public boolean canAssignPI(String userId) {
//        return true;
//    }
//    
//    public boolean canAssignUser(String userId) {
//        return true;
//    }
    
}
